unit CreateDGForm;

interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   StdCtrls, rmBtnEdit, ComCtrls, rmBaseEdit, rmWordTree;

type
   TForm1 = class(TForm)
      Button1: TButton;
      MEBtnEdit1: TrmBtnEdit;
      Label1: TLabel;
      OpenDialog1: TOpenDialog;
      ProgressBar1: TProgressBar;
      rmWordTree1: TrmWordTree;
    StaticText1: TStaticText;
      procedure MEBtnEdit1Btn1Click(Sender: TObject) ;
      procedure Button1Click(Sender: TObject) ;
      procedure MEBtnEdit1Change(Sender: TObject) ;
      procedure FormCreate(Sender: TObject) ;
      procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean) ;
   private
      CreatingDG: boolean;
      procedure AddWordToDG2(NewWord: String) ;
      procedure CreateDG(WordListFile, DGFile: string) ;
    { Private declarations }
   public
    { Public declarations }
   end;

var
   Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.MEBtnEdit1Btn1Click(Sender: TObject) ;
begin
   if opendialog1.execute then
      mebtnedit1.text := opendialog1.filename;
end;

procedure TForm1.Button1Click(Sender: TObject) ;
begin
   createDG(mebtnedit1.text, ChangeFileExt(mebtnedit1.text, '.DGF') ) ;
end;

procedure TForm1.MEBtnEdit1Change(Sender: TObject) ;
begin
   button1.enabled := fileexists(mebtnedit1.text) ;
end;

procedure TForm1.CreateDG(WordListFile, DGFile: string) ;
var
   WList: TStringList;
   WStrm: TFileStream;
   counter: integer;
   windex : integer;
begin
   WList := TStringList.Create;
   try
      StaticText1.caption := 'Loading Word File...';
      CreatingDG := true;
      progressbar1.Position := 0;
      WList.LoadFromFile(WordListFile) ;
      progressbar1.Max := WList.count;
      button1.enabled := false;
      mebtnedit1.enabled := false;
      counter := 0;
      wIndex := 0;
      StaticText1.caption := 'Processing Word List...';
      While (wIndex < WList.count) and CreatingDG and not (Application.Terminated) do
      begin
         AddWordToDG2(wList[wIndex]);
         inc(counter) ;
         inc(wIndex);
         progressbar1.Position := counter;
      end;
   finally
      CreatingDG := false;
      mebtnedit1.enabled := true;
      button1.enabled := true;
      WList.free;
      application.processmessages;
   end;
   if not application.terminated then
   begin
      StaticText1.caption := 'Saving Compiled Word List...';
      WStrm := TFileStream.create(DGFile, fmCreate) ;
      try
         WStrm.WriteComponent(rmWordTree1) ;
      finally
         WStrm.free;
      end;
   end;
end;

procedure TForm1.FormCreate(Sender: TObject) ;
begin
   CreatingDG := false;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean) ;
begin
   canclose := not CreatingDG;
end;

procedure TForm1.AddWordToDG2(NewWord: String) ;
begin
   if rmWordTree1.AddWord(newword) = nil then
      showmessage('D-Oh!');  
end;

end.

